<template>
    <div class="new-password" @keyup.enter="restore">
        <div class="warning-block">
            <b>Внимание</b><br>
            Пароль должен содержать минимум 7 символов, включающих: цифры, БОЛЬШИЕ и маленькие латинские буквы.
        </div>
        <div class="row">

            <div class="columns six">
                <label>Новый пароль:</label>
                <input type="password"
                       v-model="password"
                       name="password"
                       v-validate="'required|password'"
                       id="password"
                       :class="getValidateClass('password')"
                >
                <validate-message v-show="vErrors.has('password')">
                    {{ vErrors.first('password') }}
                </validate-message>
            </div>
            <div class="columns six">
                <label>Новый пароль еще раз:</label>
                <input type="password"
                       v-model="repeat_password"
                       name="repeat_password"
                       v-validate="'required|password'"
                       id="repeat-password"
                       :class="getValidateClass('repeat_password')"
                >
                <validate-message v-show="vErrors.has('repeat_password')">
                    {{ vErrors.first('repeat_password') }}
                </validate-message>
            </div>
        </div>
        <div class="row center">
            <button @click="restore"
                    :disabled="$interface.buttonLoading"
                    :class="{button_loading: $interface.buttonLoading}"
                    class="button red"
            >
                Подтвердить
            </button>
        </div>

        <loader ref="loader"
                v-bind="{
                      name: 'restoreLoader',
                      isShow: loading,
                      waitingTitle: waitingTitle,
                      caption: caption,
                  }"
                style="z-index: 501"
        />
    </div>
</template>

<script>
	import GetValidateClass from '@/mixins/Validation/GetValidateClassMixin';
	import restoreSms from '@/utils/error_mapper/restore_password_per_sms';
	import ToggleChat from '@/mixins/Chat/ToggleChat';
	import loader from '@/components/Loader';
	export default {
		name: 'NewPassword',
		mixins: [GetValidateClass, ToggleChat],
		props: ['inicial'],
        components: {
			loader
        },
		data() {
			return {
				password: '',
				repeat_password: '',
				goodPassword: false,

                loading: false,
                waitingTitle: 'Сохранение',
                caption: '',
			};
		},


		computed: {
			disabled() {
				return this.goodPassword && this.password === this.repeat_password;
			},
		},

		created() {
			this.$validator.extend('password', {
				validate: (value) => {
					this.goodPassword = /^(?=.*\d)(?=.*[a-z])(?=.*[A-Z]).{7,}$/.test(value);
					return this.goodPassword;
				},
				getMessage: (field) => {
					console.log(field);
					if (this.password && this.repeat_password) {
						return this.password === this.repeat_password ?
							field === 'password' ? 'Слишком простой пароль' : '' :
							'Пароли не совпадают';
					}
					return field === 'repeat_password' ? '' : 'Слишком простой пароль';
				},
			});
		},
		methods: {
			async restore() {

				this.$validator.validateAll().then((v) => {

					if(v && this.password !== this.repeat_password) {
						this.vErrors.add('password', 'Пароли не совпадают');
						this.vErrors.add('repeat_password', ' ');
						return;
                    }

					const header = {
						Authorization: 'Bearer ' + this.inicial.token,
					};
					if (v) {
						this.BUTTON_LOADING(true);
						this.loading = true;


						this.$backend.instance.post('user/password/reset', {
							new_password: this.password,
							confirm_new_password: this.repeat_password,
						}, {headers: header}).then(() => {

							this.waitingTitle = 'Загрузка профиля'
							this.$toastr.success('Ваш пароль успешно изменен.', 'Успешно');

							this.$store.commit('AUTH_SUCCESS', {data: this.inicial, authState: 'authorized'});

							return this.$methods.user.getUserData().then(async () => {
								console.log('%cSuccess auth', 'color: green');
								console.log('User', this.$user);
							}).then(() => {
								console.log('%cGet loans data', 'color: gray');
								return new Promise((resolve, reject) => {
									this.$methods.loan.getLoans().then(() => {
										console.log('%cLoans data loaded', 'color: green');
										this.$methods.user.redirect();
										return resolve();
									}).catch((code) => {
										console.error('%cLoans data load fail, code: ', code);
										return reject(code);
									})
								})
							}).catch(() => {
								this.$methods.user.logout();
							}).finally(() => {
								console.log('%cAll done', 'color: green;font-weight: bold');
								this.AJAX_LOADING(false);
							})

						}).catch((e) => {
							this.$error(e.response.data, restoreSms, 'Пароль не был изменен. Повторите запрос позднее.');
						}).finally(() => {
							this.BUTTON_LOADING(false);
							this.loading = false;
						});
					} else {
						// формальная ошибка, никогда вызвана не будет.
						this.$toastr.error('Форма установки нового пароля заполнена не верно', 'Ошибка');
					}
				}).catch((err) => {
					console.warn(err);
					this.$toastr.error(
						'Не удалось установить новый пароль. Попробуйте  еще раз или обратитесь в службу поддержки.',
                        'Ошибка');
				});
			},
		},
	};
</script>

<style scoped lang="scss">
    .new-password {
        position: relative;
    }
</style>
